﻿using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace UpDown_keys
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DoubleTextBox textbox;
        RepeatButton PART_Up, PART_Down;

        public MainWindow()
        {
            InitializeComponent();
        }

        void upDown_Loaded(object sender, RoutedEventArgs e)
        {
            textbox = upDown.Template.FindName("DoubleTextBox", upDown) as DoubleTextBox;
            PART_Up = upDown.Template.FindName("upbutton", upDown) as RepeatButton;
            PART_Down = upDown.Template.FindName("downbutton", upDown) as RepeatButton;
            if(PART_Up!=null)
                PART_Up.PreviewMouseDown += PART_Up_PreviewMouseDown;
            if (PART_Down != null)
                PART_Down.PreviewMouseDown += PART_Up_PreviewMouseDown;
        }

        void PART_Up_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            UpdateStepValue();
        }

        private void upDown_KeyDown(object sender, KeyEventArgs e)
        {
            UpdateStepValue();
        }

        private void UpdateStepValue()
        {
            int caretindex = textbox.SelectionStart;
            switch (caretindex)
            {
                case 0:
                    upDown.Step = 1.0;
                    break;
                case 1:
                    upDown.Step = 1.0;
                    break;
                case 2:
                    upDown.Step = 0.1;
                    break;
                case 3:
                    upDown.Step = 0.01;
                    break;
                case 4:
                    upDown.Step = 0.01;
                    break;
                default:
                    upDown.Step = 1.0;
                    break;
            }
        }
    }
}
